﻿<?php
class rukassaController extends Controller {
	public function index() {
		$this->load->model('users');
		$this->load->model('invoices');
		$this->load->model('waste');
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST();
			if(!$errorPOST) {
				$ammount = $this->request->post['amount'];
				$invid = $this->request->post['order_id'];
				
				$invoice = $this->invoicesModel->getInvoiceById($invid);
				$userid = $invoice['user_id'];
					
				if($ammount > 50){
					$this->usersModel->updateUser($userid, $userData = array('user_promised_pay' => 0));
				}

				$wasteData = array(
					'user_id'		=> $userid,
					'waste_ammount'	=> $ammount,
					'waste_status'	=> 0,
					'waste_usluga'	=> "Пополнение баланса пользователя",
				); 						
				$this->wasteModel->createWaste($wasteData);
					
				$this->usersModel->upUserBalance($userid, $ammount);
					
				$bonus_percent = $this->config->bonus_percent;
				$getbonus = ($ammount * (1 + $bonus_percent / 100)) - $ammount;
				$this->usersModel->upUserBonuses($userid, $getbonus);
				
				$this->usersModel->upUserBalance($userid, $ammount);				
				$this->invoicesModel->updateInvoice($invid, array('invoice_status' => 1));
				return "OK";
			} else {
				return "Error: $errorPOST";
			}
		} else {
			return "Error: Invalid request!";
		}
	}
	
	private function validatePOST() {
		$result = null;
		
		$ammount = $this->request->post['amount'];
		$in_ammount = $this->request->post['in_amount'];
		$invid = $this->request->post['order_id'];
		$sign = $_SERVER['HTTP_SIGNATURE'];
		
		$password = $this->config->rukassa_pass;
	
		if(!$this->invoicesModel->getTotalInvoices(array('invoice_id' => (int)$invid))) {
			$result = "Invalid invoice!";
		}
        elseif(strtoupper($sign) != strtoupper(hash_hmac('sha256', $this->request->post['id'] . '|' . $this->request->post['createdDateTime'] . '|' . $this->request->post['amount'], $password))) {
			$result = "Invalid signature!";
		}
		elseif($in_ammount < $ammount) {
			$result = "Not enough amount!";
		}
		
		return $result;
	}
}
?>
